/*
 * Tapioca XMPP Plugin
 * Copyright (c) 2005 INdT.
 * @author Andre Moreira Magalhaes <andre.magalhaes@indt.org.br> 
 * 
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __XMPP_INSECURE_PASSWORD_H__
#define __XMPP_INSECURE_PASSWORD_H__

#include <string>

#include <talk/base/xmpppassword.h>

class InsecurePasswordImpl : public buzz::XmppPasswordImpl {
public:
    std::string& password() { return password_; }
    const std::string& password() const { return password_; }

    InsecurePasswordImpl() {}
    InsecurePasswordImpl(const char *password) { password_ = password; }
    virtual ~InsecurePasswordImpl() {}
    virtual size_t GetLength() const { return password_.size(); }
    virtual void CopyTo(char * dest, bool nullterminate) const 
    {
        memcpy(dest, password_.data(), password_.size());
        if (nullterminate) dest[password_.size()] = 0;
    }
    virtual std::string UrlEncode() const { return password_; }
    virtual XmppPasswordImpl * Copy() const 
    {
        InsecurePasswordImpl * copy = new InsecurePasswordImpl;
        copy->password() = password_;
        return copy;
    }
    
private:
    std::string password_;
};

#endif
