/*
 * Tapioca XMPP Plugin
 * Copyright (c) 2005 INdT.
 * @author Luiz Augusto von Dentz <luiz.dentz@indt.org.br> 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#ifndef __XMPP_PRIVACY_H__
#define __XMPP_PRIVACY_H__

#include <glib.h>
#include <glib-object.h>

#include <tapioca/core/tapioca_privacy.h>

#include "xmpp_privacy_c.h"

G_BEGIN_DECLS

/* TYPE MACROS */
#define XMPP_TYPE_PRIVACY               (xmpp_privacy_get_type())
#define XMPP_PRIVACY(obj)               (G_TYPE_CHECK_INSTANCE_CAST((obj), XMPP_TYPE_PRIVACY, XmppPrivacy))
#define XMPP_PRIVACY_CLASS(klass)       (G_TYPE_CHECK_CLASS_CAST((klass), XMPP_TYPE_PRIVACY, XmppPrivacyClass))
#define IS_XMPP_PRIVACY(obj)            (G_TYPE_CHECK_INSTANCE_TYPE((obj), XMPP_TYPE_PRIVACY))
#define IS_XMPP_PRIVACY_CLASS(klass)    (G_TYPE_CHECK_CLASS_TYPE((klass), XMPP_TYPE_PRIVACY))
#define XMPP_PRIVACY_GET_CLASS(obj)     (G_TYPE_INSTANCE_GET_CLASS ((obj), XMPP_TYPE_PRIVACY, XmppPrivacyClass))
#define XMPP_PRIVACY_GET_PRIVATE(obj)   (G_TYPE_INSTANCE_GET_PRIVATE ((obj), XMPP_TYPE_PRIVACY, XmppPrivacyPrivate))

typedef struct _XmppPrivacy        XmppPrivacy;
typedef struct _XmppPrivacyClass   XmppPrivacyClass;
typedef struct _XmppPrivacyPrivate XmppPrivacyPrivate;

struct _XmppPrivacyClass {
    TapiocaPrivacyClass parent_class;
};

struct _XmppPrivacy {
    TapiocaPrivacy parent;

    XmppPrivacyPrivate *priv;
};

GType           xmpp_privacy_get_type   (void);

XmppPrivacy     *xmpp_privacy_new       (void);

void            xmpp_privacy_initialize (XmppPrivacy *xp,
                                         xmpp_privacy_t *privacy);
G_END_DECLS

#endif
